<?php

define('MODULE', 'metro');
define('TEMPLATE', 'ordersatz.tex');
define('FNAME_VARS', 'ordersatz_vars.tex');
define('FNAME_ITEMS', 'ordersatz_items.tex');
define('FAXNUMBER','2002-364');

function mk_tempdir()
{
  $tmpdir = sprintf("%sarchive/%s/%s",
		    $_SESSION['sys']['basedir'],
		    MODULE,
		    md5(date('c')));
  mkdir($tmpdir,0777);

  error_log($tmpdir);
  return $tmpdir;
}

function rm_tempdir($dir)
{
  system(sprintf("rm -rf %s", $dir));
}

function latex_encode($text)
{
  return str_replace(array("\\",'%'),
		     array('\\','\%'),
		     utf8_decode($text));
}

function ordersatz_write($id, $dir, $send)
{
  global $db;

  $fname = sprintf("%smasks/%s/%s",
		   $_SESSION['sys']['basedir'],
		   MODULE,
		   TEMPLATE);

  if (!file_exists($fname))
    return "Vorlage nicht gefunden";

  copy($fname, $dir . '/ordersatz.tex');
  chdir($dir);

  $sql = sprintf("SELECT name,koch,email,telefon,datum,uhrzeit FROM metro_ordersatz WHERE id = %d",
		 $id);
  $satz = query_db($sql);

  $f = fopen(FNAME_VARS, 'w');
  fwrite($f, sprintf('\newcommand{\koch}{%s}'."\n", latex_encode($satz[0]['koch'])));
  fwrite($f, sprintf('\newcommand{\reise}{%s}'."\n", latex_encode($satz[0]['name'])));
  fwrite($f, sprintf('\newcommand{\telefon}{%s}'."\n", latex_encode($satz[0]['telefon'])));
  fwrite($f, sprintf('\newcommand{\uhrzeit}{%s}'."\n", latex_encode($satz[0]['uhrzeit'])));

  $d = explode('-', $satz[0]['datum']);
  fwrite($f, sprintf('\newcommand{\datum}{%d.%d.%d}'."\n", $d[2], $d[1], $d[0]));
  fclose($f);

  $sql = sprintf("SELECT artnr,gang,metro_vpe.short AS vpname,menge,bezeichnung,hersteller,anzahl " .
		 "FROM metro_ordersatz_pos " .
		 "JOIN metro_artikel ON artikel = metro_artikel.id " .
		 "JOIN metro_abteilung ON abteilung = metro_abteilung.id " .
		 "JOIN metro_vpe ON vpe = metro_vpe.id " .
		 "WHERE ordersatz = %d AND anzahl IS NOT NULL " .
		 "ORDER BY gang,metro_abteilung.name",
		 $id);

#  error_log($sql);
  $result = query_db($sql);

  $f = fopen(FNAME_ITEMS, 'w');

  foreach ($result as $row) {
    $bez = $row['bezeichnung'];
    if (strlen($row['hersteller']))
      $bez .= ' (' . $row['hersteller'] . ')';

    fwrite($f, sprintf('\order{%d}{%d}{%s %s}{%s}'."\n",
		       $row['anzahl'],
		       $row['artnr'],
		       $row['menge'],
		       latex_encode($bez),
		       latex_encode($row['vpname'])));
  }

  fclose($f);

  system("latex ordersatz > ordersatz.out 2>&1 && dvips ordersatz >> ordersatz.out 2>&1 && ps2pdf ordersatz.ps", $ret);

  if ($ret !== 0)
    return "Probleme beim Compilieren des Ordersatzes";

  if (!file_exists('ordersatz.ps'))
    return "Postscript-Datei nicht erstellt";

  if ($send) {
    $cmd = sprintf("faxspool -f joey@finlandia.infodrom.org %s %s > /dev/null 2>&1",
		   FAXNUMBER,
		   ordersatz.ps);
    error_log($cmd);
    # system($cmd);

#	$fname = store_file($field, $info);


    $message = sprintf("Hallo %s!\n\nDer angehnge Ordersatz wurde gerade an Metro Oldenburg verschickt.\n\n",
		       $satz[0]['koch']);

    mail_attach($satz[0]['email'],
		'Ordersatz ' . $satz[0]['name'],
		$satz[0]['email'],
		'Infodrom ' . $satz[0]['koch'],
		array($dir . '/ordersatz.pdf'),
		$message);
  }

  return true;
}

?>